@0xe89d197dcef9c49b;

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using import "/capnp/rpc.capnp".SturdyRef;

using import "resource.capnp".Resource;

interface Resources {
    restore @0 ( sturdy :SturdyRef ) -> ( resources :Resource );
    # Restore a previously saved SturdyRef pointing to a Resource

    list @1 () -> ( resources :List(Resource) );

    getByUrn @2 ( urn :Text ) -> ( resource :Resource );
    # Returns a NULL capability if the resource doesn't exist or an user doesn't have disclose
    # permission for that resource.

    getByName @3 ( name :Text ) -> ( resource :Resource );
}
